import isBoolean from "./isBoolean";
import isObject from "./isObject";

export default function prefix(subject, prefix, delimeter = '-') {
    const prefixer = (value, key) => {
        const string = (key || value)
            .replace(new RegExp(`^${prefix}${delimeter}?`), '');

        return [prefix, string].filter(value => !!value).join(delimeter);
    };

    if(isBoolean(subject)) {
        return subject;
    }

    if(isObject(subject)) {
        return Object.fromEntries(
            Object.entries(subject).map(([key, { number }]) => [prefixer(key), number])
        );
    }

    return prefixer(subject);
}
